/***************************************************************************
 *   Copyright (C) 2005 by Andrew Krause                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "makefile-editor.h"

static bool on_delete_event (GtkWidget*, GdkEvent*, gpointer);
static void on_destroy (GtkObject*, gpointer);

// The magic all begins here...
int main (int argc, 
          char *argv[])
{
  gtk_init (&argc, &argv);
  
  if (argc > 1)
  {
    MakefileEditor *me = makefile_editor_new (argv[1]);

    g_signal_connect (G_OBJECT(me->window), "delete-event",
                      G_CALLBACK(on_delete_event), NULL);
    g_signal_connect (G_OBJECT(me->window), "destroy",
                      G_CALLBACK(on_destroy), NULL);
    g_signal_connect (G_OBJECT(me->window), "hide",
                      G_CALLBACK(on_destroy), NULL);
  
    gtk_widget_show (me->window);
    gtk_main();
  }
  else
    cout << "You must specify a project file!\n";

	
  return EXIT_SUCCESS;
}

static bool on_delete_event (GtkWidget *widget, 
                             GdkEvent *event, 
                             gpointer data)
{ return false;
}

static void on_destroy (GtkObject *object,
                        gpointer data)
{ gtk_main_quit();
}
