/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "openldev-about.h"

// Create the OpenLDev about dialog
AboutDialog* openldev_about_dialog_new (const char *version)
{
  AboutDialog *about = new AboutDialog();
  about->dialog = gtk_about_dialog_new();
  
  const gchar *authors[] = {
    "Andrew Krause <andrew@openldev.org>",
    NULL
  };

  string logo_location = string(INSTALL_PREFIX) + "/share/pixmaps/openldev/openldev48.png";
  GdkPixbuf *logo = gdk_pixbuf_new_from_file(logo_location.c_str(), NULL);
  logo = gdk_pixbuf_scale_simple(logo, 96, 96, GDK_INTERP_BILINEAR); 
  
  // Populate and show the about dialog
  gtk_about_dialog_set_logo      (GTK_ABOUT_DIALOG(about->dialog), logo);
  gtk_about_dialog_set_comments  (GTK_ABOUT_DIALOG(about->dialog), "Integrated Development Environment");
  gtk_about_dialog_set_authors   (GTK_ABOUT_DIALOG(about->dialog), authors);
  gtk_about_dialog_set_copyright (GTK_ABOUT_DIALOG(about->dialog), "(c) 2004-2005 Andrew Krause");
  gtk_about_dialog_set_name      (GTK_ABOUT_DIALOG(about->dialog), "OpenLDev");
  gtk_about_dialog_set_version   (GTK_ABOUT_DIALOG(about->dialog), version);
  gtk_about_dialog_set_website   (GTK_ABOUT_DIALOG(about->dialog), "http://www.openldev.org");
  
  logo_location = "\0";
  authors[0] = NULL;
  
  return about;
}

// Show and run the about dialog
void openldev_about_dialog_run (AboutDialog *about)
{
  int result = gtk_dialog_run (GTK_DIALOG(about->dialog));
  
  switch (result)
  {
    default:
      return;
  }
}
