/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef ENVIRONMENT_DIALOG_H
#define ENVIRONMENT_DIALOG_H

#include <gtk/gtk.h>
#include <glade/glade.h>
#include <iostream>
using namespace std;

typedef struct _EnvironmentDialog  EnvironmentDialog;

struct _EnvironmentDialog
{
  GtkWidget *autosave;
  GtkWidget *autoindent;
  GtkWidget *bracket;
  GtkWidget *error;
  GtkWidget *fontbutton;
  GtkWidget *load_on_launch;
  GtkWidget *replace_tabs;
  GtkWidget *right_margin;
  GtkWidget *split_words;
  GtkWidget *tab_size;
  GtkWidget *undo_actions;
  GtkWidget *warning;
  GtkWidget *wrap;
  
  GtkWidget *cancel;
  GtkWidget *dialog;
  GtkWidget *ok;
  GtkWidget *label_autoindent;
  GtkWidget *label_bracket;
  GtkWidget *label_compiler;
  GtkWidget *label_filemanagement;
  GtkWidget *label_font;
  GtkWidget *label_rightmargin;
  GtkWidget *label_tabstops;
  GtkWidget *label_text_wrap;
  GtkWidget *label_undo;
  
  string fontname;
};

EnvironmentDialog* openldev_env_dialog_new        ();
GtkWidget*         openldev_env_dialog_get_dialog (EnvironmentDialog*);
int                openldev_env_dialog_run        (EnvironmentDialog*);

void openldev_env_dialog_set_autosave       (EnvironmentDialog*, int);
void openldev_env_dialog_set_undo           (EnvironmentDialog*, int);
void openldev_env_dialog_set_tab_size       (EnvironmentDialog*, int);
void openldev_env_dialog_set_autoindent     (EnvironmentDialog*, bool);
void openldev_env_dialog_set_bracket        (EnvironmentDialog*, bool);
void openldev_env_dialog_set_load_on_launch (EnvironmentDialog*, bool);
void openldev_env_dialog_set_replace_tabs   (EnvironmentDialog*, bool);
void openldev_env_dialog_set_right_margin   (EnvironmentDialog*, bool);
void openldev_env_dialog_set_split_words    (EnvironmentDialog*, bool);
void openldev_env_dialog_set_wrap           (EnvironmentDialog*, bool);
void openldev_env_dialog_set_error          (EnvironmentDialog*, const char*);
void openldev_env_dialog_set_font           (EnvironmentDialog*, const char*, const char*);
void openldev_env_dialog_set_warning        (EnvironmentDialog*, const char*);

int openldev_env_dialog_get_autosave (EnvironmentDialog*);
int openldev_env_dialog_get_undo     (EnvironmentDialog*);
int openldev_env_dialog_get_tab_size (EnvironmentDialog*);

bool openldev_env_dialog_get_autoindent     (EnvironmentDialog*);
bool openldev_env_dialog_get_bracket        (EnvironmentDialog*);
bool openldev_env_dialog_get_load_on_launch (EnvironmentDialog*);
bool openldev_env_dialog_get_replace_tabs   (EnvironmentDialog*);
bool openldev_env_dialog_get_right_margin   (EnvironmentDialog*);
bool openldev_env_dialog_get_split_words    (EnvironmentDialog*);
bool openldev_env_dialog_get_wrap           (EnvironmentDialog*);

const char* openldev_env_dialog_get_error     (EnvironmentDialog*);
const char* openldev_env_dialog_get_font_size (EnvironmentDialog*);
const char* openldev_env_dialog_get_font_face (EnvironmentDialog*);
const char* openldev_env_dialog_get_warning   (EnvironmentDialog*);

#endif
