/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-input.h"

const char* openldev_input_dialog_run (const char* label_text, 
                                       const char* title)
{
  InputDialog *input = new InputDialog();

  input->dialog = gtk_dialog_new ();
  input->cancel = gtk_button_new_from_stock ("gtk-cancel");
  input->ok =     gtk_button_new_from_stock ("gtk-ok");
  input->label =  gtk_label_new (label_text);
  input->entry =  gtk_entry_new ();
  input->hbox =   gtk_hbox_new (false, 0);
  
  GTK_WIDGET_SET_FLAGS (input->ok, GTK_CAN_DEFAULT);
  gtk_container_set_border_width (GTK_CONTAINER(input->hbox), 10);
  gtk_box_set_spacing (GTK_BOX(input->hbox), 10);
  gtk_box_pack_start (GTK_BOX(input->hbox), input->label, false, false, 0);
  gtk_box_pack_start (GTK_BOX(input->hbox), input->entry, false, true, 0);

  gtk_box_pack_start (GTK_BOX(GTK_DIALOG(input->dialog)->vbox),
                      input->hbox, TRUE, TRUE, 0);
  gtk_window_set_title (GTK_WINDOW(input->dialog), title);
  gtk_window_set_modal (GTK_WINDOW(input->dialog), false);
  gtk_window_set_resizable (GTK_WINDOW(input->dialog), true);
  gtk_dialog_set_has_separator (GTK_DIALOG(input->dialog), true);
  gtk_dialog_add_action_widget (GTK_DIALOG(input->dialog), input->cancel, -6);
  gtk_dialog_add_action_widget (GTK_DIALOG(input->dialog), input->ok, -5);
  
  gtk_widget_show_all (input->dialog);

  int result = gtk_dialog_run (GTK_DIALOG(input->dialog));
  
  switch (result)
  {
    case -5:
    {
      string text = gtk_entry_get_text (GTK_ENTRY(input->entry));
      gtk_widget_destroy (input->dialog);
      delete input;
      return text.c_str();
    }
    default:
    {
      gtk_widget_destroy (input->dialog);
      delete input;
      return "EMPTY";
    }
  }
  
  return "EMPTY";
}
