/***************************************************************************
 *   Copyright (C) 2005 by Andrew Krause                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef OPENLDEV_MAKEFILE_PARSER_H
#define OPENLDEV_MAKEFILE_PARSER_H

#include <iostream>
#include <vector>
#include <string>
#include <fstream>
using namespace std;

enum { MAKEFILE_STRING, MAKEFILE_COMMENT, 
       MAKEFILE_SCRIPT, MAKEFILE_ARRAY };

typedef struct _Makefile  Makefile;
typedef struct _MakefileAttr  MakefileAttr;

struct _MakefileAttr
{
  vector<string> attr;
};

struct _Makefile
{
  vector<int> types;
  vector<MakefileAttr*> attributes;
  vector<string> names;
  string filename;
};

Makefile* openldev_makefile_parser_new (const char*);
void openldev_makefile_parser_write (Makefile*);

vector<string> openldev_makefile_parser_get_subdirs (Makefile*);
vector<string> openldev_makefile_parser_get_sources (Makefile*);

#endif
