/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "openldev-project-template.h"

string openldev_project_template_get_xml_attribute (string, xmlDocPtr&);

ProjectTemplate* openldev_project_template_new (const char* file)
{
  ProjectTemplate *templ = new ProjectTemplate();

  string filename = string(INSTALL_PREFIX) + "/share/openldev/templates/" + file + ".template";
  xmlDocPtr doc = xmlParseFile (filename.c_str());
  xmlNodePtr cur;

  if (doc != NULL) 
  {
    cur = xmlDocGetRootElement(doc);
    if (!xmlStrcmp(cur->name, (const xmlChar *) "project"))
    {
      templ->tar = openldev_project_template_get_xml_attribute("template", doc);
      templ->title = openldev_project_template_get_xml_attribute("title", doc);
      templ->language = openldev_project_template_get_xml_attribute("language", doc);
      templ->compile = openldev_project_template_get_xml_attribute("compile", doc);
      templ->build = openldev_project_template_get_xml_attribute("build", doc);
      templ->autogen = openldev_project_template_get_xml_attribute("autogen", doc);
      templ->configure = openldev_project_template_get_xml_attribute("configure", doc);
      templ->clean = openldev_project_template_get_xml_attribute("clean", doc);
    }
  }
  
  xmlFreeDoc(doc);
  cur = NULL;  
  return templ;
}

string openldev_project_template_get_xml_attribute (string element, 
                                                    xmlDocPtr &doc)
{
  xmlNodePtr cur = xmlDocGetRootElement(doc);
  cur = cur->xmlChildrenNode;
  
  while (cur != NULL)
  {
    if (!xmlStrcmp(cur->name, (const xmlChar *) element.c_str()))
    {
      const char *key = (const char*)xmlNodeListGetString (doc, cur->xmlChildrenNode, 1);
      cur = NULL;
      return key;
    }
    
    cur = cur->next;
  }
  
  cur = NULL;
  return "";
}
