/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#include "openldev-template-list.h"

string openldev_template_list_read_file (string filename);

TemplateList* openldev_template_list_new ()
{
  TemplateList *list = new TemplateList();

  string directory = string(INSTALL_PREFIX) + "/share/openldev/templates/", name;
  unsigned int l;

  vector<string> entries;
  const char* fn;
  GDir *dir = g_dir_open (directory.c_str(), 0, NULL);
  while ((fn = g_dir_read_name(dir)) != NULL)
    entries.push_back (fn);
  
  for (l=0; l < entries.size(); l++)
    if ((entries.at(l).find(".template", 0) != string::npos) && (entries.at(l) != "index.template"))
      list->file.push_back(entries.at(l).substr(0, entries.at(l).find(".template", 0)));
  entries.clear();

  for (l=0; l < list->file.size(); l++)
  {
    string str = openldev_template_list_read_file(directory + list->file.at(l) + ".template");
    str.erase(0, str.find("<title>", 0) + 7);
    str.erase(str.find("</title>", 0), str.length() - str.find("</title>", 0));
    list->title.push_back(str);
  }
  
  return list;
}

// Read in the text from a file. This function receives a filename and returns
// the text string of the file.
string openldev_template_list_read_file (string filename)
{
  if (!g_file_test(filename.c_str(), G_FILE_TEST_EXISTS))
    return string("");
  
  string text;
  string line;
  ifstream fin(filename.c_str());
  while (getline(fin, line))
    text += g_locale_to_utf8 (line.c_str(), -1, NULL, NULL, NULL) + string("\n");
  
  return text;
}
