/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef BROWSER_PROJECT_H
#define BROWSER_PROJECT_H

#include "../openldev-settings/openldev-project.h"

#include <gtk/gtk.h>
#include <vector>
#include <iostream>
#include <dirent.h>
#include <libgnomevfs/gnome-vfs.h>
#include <libgnomeui/gnome-icon-lookup.h>

typedef struct _BrowserProject  BrowserProject;

struct _BrowserProject
{
  GtkWidget *treeview;
  GtkWidget *scrolled_window;
  
  string base;
  string current;
};

BrowserProject* openldev_browser_project_new ();
const char*     openldev_browser_project_get_selected_file (BrowserProject*);

void openldev_browser_project_populate (BrowserProject*, const char*);
void openldev_browser_project_move_up  (BrowserProject*);
void openldev_browser_project_move     (BrowserProject*, const char*);
void openldev_browser_project_refresh  (BrowserProject*);

#endif
