/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-goto-line-toolbar.h"

GotoLineToolbar* openldev_goto_toolbar_new ()
{
  GotoLineToolbar *toolbar = new GotoLineToolbar();
  
  // Create Horizontal Goto Line 'Toolbar'
  GtkAdjustment *spinbutton_adj;
  spinbutton_adj = GTK_ADJUSTMENT(gtk_adjustment_new(1, 1, 99999, 1, 10, 10));
  toolbar->button_close = gtk_button_new();
  toolbar->label_goto_line = gtk_label_new("Goto Line: ");
  toolbar->button_goto_line = gtk_button_new_from_stock("gtk-jump-to");
  toolbar->image_error = gtk_image_new_from_stock("gtk-dialog-error", GTK_ICON_SIZE_MENU);
  toolbar->image_close = gtk_image_new_from_stock("gtk-stop", GTK_ICON_SIZE_MENU);
  toolbar->label_error = gtk_label_new("Line out of bounds!");  
  toolbar->goto_line = gtk_spin_button_new(spinbutton_adj, 1, 0);
  toolbar->hbox = gtk_hbox_new(false, 0);

  // Create the buttons
  gtk_button_set_relief (GTK_BUTTON(toolbar->button_close), GTK_RELIEF_NONE);
  gtk_container_add (GTK_CONTAINER(toolbar->button_close), toolbar->image_close);
  gtk_button_set_relief (GTK_BUTTON(toolbar->button_goto_line), GTK_RELIEF_NONE);
  
  // Add the widgets to the horizontal box
  gtk_box_set_spacing (GTK_BOX(toolbar->hbox), 5);
  gtk_container_set_border_width (GTK_CONTAINER(toolbar->hbox), 3);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->button_close, false, false, 0);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->label_goto_line, false, false, 0);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->goto_line, false, false, 0);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->button_goto_line, false, false, 5);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->image_error, false, false, 0);
  gtk_box_pack_start (GTK_BOX(toolbar->hbox), toolbar->label_error, false, false, 0);
  
  return toolbar;
}

void openldev_goto_toolbar_show_error (GotoLineToolbar *toolbar,
                                       bool show)
{
  if (show)
  {
    gtk_widget_show(toolbar->label_error);
    gtk_widget_show(toolbar->image_error);
  }
  else
  {
    gtk_widget_hide(toolbar->label_error);
    gtk_widget_hide(toolbar->image_error);
  }
}

int  openldev_goto_toolbar_get_goto_value (GotoLineToolbar *toolbar)
{ return gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(toolbar->goto_line));
}
