/***************************************************************************
 *   Copyright (C) 2004-2005 by Andrew Krause                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "openldev-menu.h"

MenuHandle* openldev_menu_handle_new ()
{
  MenuHandle *handle = new MenuHandle();
  
  handle->menubar = gtk_menu_bar_new ();
  handle->popup = gtk_menu_new ();
  handle->toolbar = gtk_toolbar_new ();
  handle->group = gtk_action_group_new ("ActionGroup");
  handle->uimanager = gtk_ui_manager_new ();
  
  return handle;
}

GtkWidget* openldev_menu_handle_get_menubar (MenuHandle* handle)
{ return handle->menubar;
}

GtkWidget* openldev_menu_handle_get_popup   (MenuHandle* handle)
{ return handle->popup;
}

GtkWidget* openldev_menu_handle_get_toolbar (MenuHandle* handle)
{ return handle->toolbar;
}

GtkActionGroup* openldev_menu_handle_get_action_group (MenuHandle* handle)
{ return handle->group;
}

GtkUIManager* openldev_menu_handle_get_uimanager (MenuHandle* handle)
{ return handle->uimanager;
}
